/*****************************************************************
*  isim    : Direnc deeri hesaplayc                           *
*  Yazan   : Erhan YILMAZ (tekniker_erhan)                       *
*  tarih   : 25.03.2010                                          *
*  Srm   : 1.0                                                 *
*  Notlar  :Devre 4 renk direnlerin diren ve tlerans deerini *
*          :hesaplar ekranda gsterir. 							 *
*****************************************************************/

#include <htc.h>
#include <stdio.h>
#define	XTAL_FREQ	4MHZ
#include "delay.h"
#include "3310.h"
#include "resim.h"

__CONFIG(UNPROTECT	&	CCPRB0	&	DEBUGDIS	&	UNPROTECT	&	UNPROTECT	&	LVPDIS	&	BORDIS	&	MCLREN & PWRTEN & WDTDIS & INTIO & FCMDIS & IESODIS);

unsigned char tus,tus_sayi=0;
char direnc [4];//4 elemalk direnc renk kodu dizisi

//4x3 tu takm sren fonksiyon
void  tus_tara (void){
	tus=0xFF;
	RB0=0;RB1=1;RB2=1;
	if (!RB3)tus=0;
	if (!RB4)tus=3;
	if (!RB5)tus=6;
	if (!RB6)tus=9;
	RB0=1;RB1=0;
	if (!RB3)tus=1;
	if (!RB4)tus=4;
	if (!RB5)tus=7;
	if (!RB6)tus=10;
	RB1=1;RB2=0;
	if (!RB3)tus=2;
	if (!RB4)tus=5;
	if (!RB5)tus=8;
	if (!RB6)tus=11;
	bekle_ms(400);
}
//Tu numarasna uygun renk kodu ilgili satrda yazan fonksiyon
void tablo (unsigned char deger){
	switch (deger)
	{
	case 0: nokia_printchar ("Siyah  ");break;
	case 1: nokia_printchar ("Kahve  ");break;
	case 2: nokia_printchar ("Kirmizi");break;
	case 3: nokia_printchar ("Turuncu");break;
	case 4: nokia_printchar ("Sari   ");break;
	case 5: nokia_printchar ("Yesil  ");break;
	case 6: nokia_printchar ("Mavi   ");break;
	case 7: nokia_printchar ("Mor    ");break;
	case 8: nokia_printchar ("Gri    ");break;
	case 9: nokia_printchar ("Beyaz  ");break;
	case 10: nokia_printchar("Altin  ");break;
	case 11: nokia_printchar("Gumus  ");break;}
	}

// Bu fonksiyonda diren deeri hesaplanr 3. renk koduna gre dierncin 
// ohm cinsinden deerini belirtir. 0,1 ohm ile 99 Giga ohm arasdna diren deerini hesaplar.
void direnc_hesap (void){
	char gosster[6];
	nokia_gotoxy(1,0);nokia_printchar("Direnc=");

	if (direnc[2]==0)
	{nokia_print(direnc[0]+0x30);nokia_print(direnc[1]+0x30);nokia_printchar("ohm");}
	
	if (direnc[2]==1)
	{nokia_print(direnc[0]+0x30);nokia_print(direnc[1]+0x30);nokia_printchar("0ohm");}
	
	if (direnc[2]==2)
	{nokia_print(direnc[0]+0x30);if (!direnc[1]==0){nokia_print(',');nokia_print(direnc[1]+0x30);}nokia_printchar("Kohm");}
	
	if (direnc[2]==3)
	{nokia_print(direnc[0]+0x30);nokia_print(direnc[1]+0x30);nokia_printchar("Kohm");}
	
	if (direnc[2]==4)
	{nokia_print(direnc[0]+0x30);nokia_print(direnc[1]+0x30);nokia_printchar("0Kohm");}
	
	if (direnc[2]==5)
	{nokia_print(direnc[0]+0x30);if (!direnc[1]==0){nokia_print(',');nokia_print(direnc[1]+0x30);}nokia_printchar("Mohm");}
	
	if (direnc[2]==6)
	{nokia_print(direnc[0]+0x30);nokia_print(direnc[1]+0x30);nokia_printchar("Mohm");}
	
	if (direnc[2]==7)
	{nokia_print(direnc[0]+0x30);nokia_print(direnc[1]+0x30);nokia_printchar("0Mohm");}
	
	if (direnc[2]==8)
	{nokia_print(direnc[0]+0x30);if (!direnc[1]==0){nokia_print(',');nokia_print(direnc[1]+0x30);}nokia_printchar("Gohm");}
	
	if (direnc[2]==9)
	{nokia_print(direnc[0]+0x30);nokia_print(direnc[1]+0x30);nokia_printchar("Gohm");}
	
	if (direnc[2]==10)
	{nokia_print(direnc[0]+0x30);if(!direnc[1]==0){nokia_print(',');nokia_print(direnc[1]+0x30);}nokia_printchar("ohm");}
	
	if (direnc[2]==11)
	{nokia_printchar("0,");nokia_print(direnc[0]+0x30);if(!direnc[1]==0)nokia_print(direnc[1]+0x30);nokia_printchar("ohm");}
	
//son renk koduna baklarak tlerans deeri hesaplanr.
	nokia_gotoxy(6,1);nokia_printchar("Tolerans=%");	
	if (direnc[3]==10)nokia_printchar("5 ");
	if (direnc[3]==11)nokia_printchar("10");
}
//baslan tuun deeri renk olarak diziye eklenir.
void renk_ekle (void){
	nokia_gotoxy(15,tus_sayi+2);
		tablo (direnc[tus_sayi]);
		tus_sayi++;
		tus=0;
}
//Ekran satrlarn siler ve satrlara 1,2,3,4 rakamlarn yazar.
void ekran_temizle(void){
	char i,j;
	for (j=0;j<2;j++){nokia_gotoxy(0,j);for(i=0;i<14;i++)nokia_print(' ');}
	for (i=1;i<5;i++)
	{nokia_gotoxy(3,i+1);
	nokia_print(i+0x30);
	nokia_print('-');
	for(j=0;j<9;j++)nokia_print(' ');}}

void main(void)
{	int i;
	OSCCON=0x6C;
	TRISB = 0xF8;
	TRISA = 0X00;
	PORTB = 0XFF;
	PORTA = 0x00;
	CMCON = 0x07;
	ANSEL = 0x00;
	RBPU = 0;
	nokia_init();
	nokia_gotoxy(0,0);
	for(i=0;i<504;i++)
	nokia_write_data(resim[i]);
	bekle_ms(500);bekle_ms(500);
	bekle_ms(500);bekle_ms(500);
	nokia_clean_ddram();
	ekran_temizle();
	nokia_gotoxy(18,0);
	nokia_printchar("Renkleri");
	nokia_gotoxy(18,1);
	nokia_printchar("Tuslayin");

	while(1){
	tus_tara();
	if(tus!=0xFF){
	switch (tus_sayi){
	//1. renk olarak siyah ,altn ,gm girilmesini nleyen kod
	case 0: if ((!tus==0) && tus!=10 && tus!=11){ekran_temizle();;direnc[0]=tus;renk_ekle();}break;
	//2. renk olarak altn ve gm girilmesini engelleyen kod
	case 1: if(tus!=10 && tus!=11){direnc[1]=tus;renk_ekle();}break;
	//3. renk olarak btn renkler girilebilir.
	case 2: direnc[2]=tus;renk_ekle(); break;
	//4. renk olarak altn ve gm harici renk girilmesini nleyen kod
	case 3: if(tus==10 || tus==11){direnc[3]=tus;renk_ekle();direnc_hesap();tus_sayi=0;}break;}}
		}
	}	
 
       


 
